#include <windows.h>
#include "ring0.h"


/******************************************************************************/
/*                         !!!   Win9x !!!                           */
/******************************************************************************/

void  Ring0FarFunc();

__declspec(naked) BOOL CallRing0(PRING0FUNC pRing0Func, DWORD dwParams,
                                 LPDWORD lpdwRetValue)
{
  __asm
  {
    push  ebp
    mov   ebp,esp
    push  esi

    /*    LDT */
    sldt  ax                  /* AX =  LDT */
    and   eax,0FFF8h
    jz    NoFreeEntries

    push  esi
    sgdt  FWORD PTR [esp-2]
    pop   esi                 /* ESI =   GDT */
    add   esi,eax

    movzx ecx,WORD PTR [esi]
    inc   ecx
    shr   ecx,3               /* ECX =    LDT */
    mov   edx,[esi+1]
    mov   dl,[esi+7]
    ror   edx,8               /* EDX =   LDT */
    mov   esi,edx

    /*     LDT */
EntryLoop:
    cmp   BYTE PTR [esi+5],0
    je    FoundFreeEntry
    add   esi,8
    loop  EntryLoop

NoFreeEntries:
    xor   eax,eax
    jmp   Done

FoundFreeEntry:
    /*    LDT */

    /*   LDT    */
    mov   eax,OFFSET Ring0FarFunc
    mov   DWORD PTR [esi],eax
    mov   DWORD PTR [esi+4],eax
    mov   DWORD PTR [esi+2],0EC000028h

    /*      */
    mov   eax,esi
    sub   eax,edx
    or    al,7                /* AX =    */
    push  ax
    push  eax
    mov   eax,[pRing0Func]
    mov   ecx,[dwParams]
    call  FWORD PTR [esp]
    add   esp,6
    mov   ecx,[lpdwRetValue]
    jecxz FreeEntry
    mov   DWORD PTR [ecx],eax

FreeEntry:
    /*   LDT */
    xor   eax,eax
    mov   DWORD PTR [esi],eax
    mov   DWORD PTR [esi+4],eax
    inc   eax

Done:
    pop   esi
    pop   ebp
    ret
  }
}

__declspec(naked) void Ring0FarFunc()
{
  __asm
  {
    call  eax
    retf
  }
}
